
// UBUNTU
//

#include <stdio.h>
#include <sys/types.h>
#include <malloc.h>
#include <math.h>
#include <pulse/simple.h>
#include <pulse/error.h>



// DEBIAN
/*
#include <stdio.h>
#include <stdint.h>
#include <unistd.h>
#include <fcntl.h>
#include <malloc.h>
#include <math.h>
#include <sys/soundcard.h>
#define MIN(a, b) ((a < b) ? a : b)
*/

#define PI 3.141592653589793238462
#define RATE 44100

#define G8 get8(music_data, &music_seek)
#define G16 get16(music_data, &music_seek)
#define G32 get32(music_data, &music_seek)

#define M8(v) (uint8_t *)malloc(sizeof(uint8_t) * v)
#define M16(v) (uint16_t *)malloc(sizeof(uint16_t) * v)
#define M32(v) (uint32_t *)malloc(sizeof(uint32_t) * v)

/*
#define //PIK(v) printf("$_->"); printf(v); printf(" = ");
#define //MIK(v) if (v == NULL) printf("KIK !\n"); else printf("pointeur obtenu at %p\n", v)

void //printmem8(uint8_t *pointer, uint32_t psize) {
    uint32_t i;
    if (psize > 32) psize = 32;
    for (i = 0; i < psize; i++) {
        //printf("	at[%d] : %p = %d\n", i, &pointer[i], pointer[i]);
    }
}

void //printmem16(uint16_t *pointer, uint32_t psize) {
    uint32_t i;
    if (psize > 32) psize = 32;
    for (i = 0; i < psize; i++) {
        //printf("	at[%d] : %p = %d\n", i, &pointer[i], pointer[i]);
    }
}

void //printmem32(uint32_t *pointer, uint32_t psize) {
    uint32_t i;
    if (psize > 32) psize = 32;
    for (i = 0; i < psize; i++) {
        //printf("	at[%d] : %p = %d\n", i, &pointer[i], pointer[i]);
    }
}

void //printmemdb(double *pointer, uint32_t psize) {
    uint32_t i;
    if (psize > 32) psize = 32;
    for (i = 0; i < psize; i++) {
        //printf("	at[%d] : %p = %f\n", i, &pointer[i], pointer[i]);
    }
        //printf("	lastat[%d] : %p = %f\n", psize - 1, &pointer[psize - 1], pointer[psize - 1]);
}

void //printdmem32(uint32_t **pointer, uint32_t psize) {
    uint32_t i;
    if (psize > 32) psize = 32;
    for (i = 0; i < psize; i++) {
        //printf("	at[%d] : %p = %p\n", i, &pointer[i], pointer[i]);
    }
}
*/
uint8_t get8(uint8_t *music_data, uint32_t *music_seek) {
    uint8_t get = music_data[*music_seek];
        ////printf("seek %d value %d\n", *music_seek, get);
    *music_seek = *music_seek + 1;
    ////printf("return %d\n", get);
    return get;
}

uint16_t get16(uint8_t *music_data, uint32_t *music_seek) {
    uint16_t get[2],i;
    for (i = 0; i < 2; i++) {
        get[i] = music_data[*music_seek];
       ////printf("seek %d value %d\n", *music_seek, get[i]);
        *music_seek = *music_seek + 1;
    }
    ////printf("return %d\n", (get[0] * 256 + get[1]));
    return get[0] * 256 + get[1];
}

uint32_t get32(uint8_t *music_data, uint32_t *music_seek) {
    uint32_t get[4],i;
    for (i = 0; i < 4; i++) {
        get[i] = music_data[*music_seek];
        ////printf("seek %d value %d\n", *music_seek, get[i]);
        *music_seek = *music_seek + 1;
    }
    ////printf("return %d\n", ( get[0] * 16777216 + get[1] * 65536 + get[2] * 256 + get[3]));
    return get[0] * 16777216 + get[1] * 65536 + get[2] * 256 + get[3];
}


uint32_t del_len(
  uint8_t del, 
  uint32_t tap_len,
  uint32_t *envs_len,
  uint8_t **dels, 
  uint8_t *dels_cnt,
  uint8_t **taps, 
  uint8_t *taps_cnt,
  uint8_t ecos_,
  uint32_t *ecos_rep, 
  uint8_t *ecos_vol 
) {
    //printf("DEL_LEN\n");
    uint32_t ecos_len = 0;
    uint32_t i, j, k, l, eco_len;
    //printf("tap_len %d\n", tap_len);
    //printf("DEL %d\n", del);
    for (i = 0; i < dels_cnt[del]; i++) {
        // pour chaque ecos dans taps
        //printf("TAP %d (%d)\n", dels[del][i], taps_cnt[dels[del][i]]);
        for (j = 0; j < taps_cnt[dels[del][i]] ; j++) {
            ecos_len = 0;
            //printf("	ECO %d\n", taps[dels[del][i]][j]);

            //printf("		ecos_rep %d\n", ecos_rep[  taps[dels[del][i]][j] ]);
            //printf("		ecos_vol %d\n", ecos_vol[  taps[dels[del][i]][j] ]);
            //printf("		envs_len %d\n", envs_len[ecos_vol[ taps[dels[del][i]][j]  ]]);
            eco_len = envs_len[ecos_vol[ taps[dels[del][i]][j]  ]];
            //printf("		.eco_len vs tap_len %d %d\n", eco_len, tap_len);
            if (eco_len < tap_len) 
                eco_len = tap_len;
            ////printf("		>eco_len %d\n", eco_len);
		/*
            k = ecos_rep[ taps[dels[del][i]][j]  ]; 
            while (k < eco_len) {
                 k += ecos_rep[ taps[dels[del][i]][j]  ];
            }*/
           // //printf("for (k = ecos_rep[ taps[dels[del][i]][j]  ]; k < eco_len;  k += ecos_rep[ taps[dels[del][i]][j]  ])\n" );
           // //printf("for (k = %d; k < %d; k += %d)\n", ecos_rep[ taps[dels[del][i]][j]  ], eco_len, ecos_rep[ taps[dels[del][i]][j]  ]);

            for (k = ecos_rep[ taps[dels[del][i]][j]  ]; 
                 k < envs_len[ecos_vol[ taps[dels[del][i]][j]  ]];
                 k += ecos_rep[ taps[dels[del][i]][j]  ]) {
                ////printf("k is %d\n", k);
            }
            ////printf("		after while k %d\n", k);
            k -= ecos_rep[ taps[dels[del][i]][j]  ];

            ////printf("		after reduce k %d\n", k);
            ////printf("		tap_len %d\n", tap_len);
            if (ecos_len < (k + tap_len)  )
                ecos_len = (k + tap_len);
           // //printf("		ecos_len %d\n", ecos_len);
        }
        tap_len = ecos_len;
    }
    //printf("del_len return %d\n", ecos_len);
    return ecos_len;
}

void del_cal(
  double *src_l,
  double *src_r,
  uint32_t src_len,
  uint32_t dst_len, 
  uint8_t del,
  uint8_t **dels, 
  uint8_t *dels_cnt,
  uint8_t **taps,
  uint8_t *taps_cnt,
  uint8_t ecos_,
  uint32_t *ecos_rep,
  uint8_t *ecos_vol,
  uint8_t *ecos_pan,
  double **envs_cal,
  uint32_t *envs_len,
  double b321
) {
    //printf("DEL_CAL\n");
    uint32_t i, j, k, l, m;

    double vol, pan;
    double *del_l;
    double *del_r;
    double *tap_l;
    double *tap_r;
    double ***eco_l;
    double ***eco_r;

    del_l = (double *)malloc(sizeof(double) * dst_len);
        //PIK("del_l");
        //MIK(del_l);
        //printmemdb(del_l, dst_len);
    del_r = (double *)malloc(sizeof(double) * dst_len);
        //PIK("del_r");
        //MIK(del_r);
        //printmemdb(del_r, dst_len);

    tap_l = (double *)malloc(sizeof(double) * dst_len);
        //PIK("tap_l");
        //MIK(tap_l);
        //printmemdb(tap_l, dst_len);
    tap_r = (double *)malloc(sizeof(double) * dst_len);
        //PIK("tap_r");
        //MIK(tap_r);
        //printmemdb(tap_r, dst_len);
    for (i = 0; i < dst_len; i++) {
         tap_l[i] = src_l[i];
         tap_r[i] = src_r[i];
    }
    uint32_t ecos_len, eco_len, tap_len = src_len;
   
    eco_l = (double ***)malloc(sizeof(double **) * dels_cnt[del]);
        //PIK("eco_l");
        //MIK(eco_l);
    eco_r = (double ***)malloc(sizeof(double **) * dels_cnt[del]);
        //PIK("eco_r");
        //MIK(eco_r);
  
    //printf("DEL %d\n", del);
    // pour chaque tap
    for (i = 0; i < dels_cnt[del]; i++) {
        //printf("TAP %d (%d)\n", dels[del][i], taps_cnt[dels[del][i]]);
        // pour chaque ecos dans taps
        eco_l[i] = (double **)malloc(sizeof(double *) * taps_cnt[dels[del][i]]);
        //PIK("eco_l[i]");
        //MIK(eco_l[i]);
        eco_r[i] = (double **)malloc(sizeof(double *) * taps_cnt[dels[del][i]]);
        //PIK("eco_r[i]");
        //MIK(eco_r[i]);
        for (j = 0; j < taps_cnt[dels[del][i]] ; j++) {
            ecos_len = 0;
            //printf("	ECO %d\n", taps[dels[del][i]][j]);
            //printf("	ecos_rep %d\n", ecos_rep[  taps[dels[del][i]][j] ]);
            //printf("	ecos_vol %d\n", ecos_vol[  taps[dels[del][i]][j] ]);
            eco_l[i][j] = (double *)malloc(sizeof(double) * dst_len);
        //PIK("eco_l[i][j]");
        //MIK(eco_l[i][j]);
            eco_r[i][j] = (double *)malloc(sizeof(double) * dst_len);
        //PIK("eco_r[i][j]");
        //MIK(eco_r[i][j]);
            //printf("	eco_ ok\n");
            for (k = 0; k < dst_len; k++) {
                eco_l[i][j][k] = 0;
                eco_r[i][j][k] = 0;
            }
           // //printf("	eco_ 0\n");
            eco_len = envs_len[ecos_vol[ taps[dels[del][i]][j]  ]];
            if (eco_len < tap_len) 
                eco_len = tap_len;
            for (k = ecos_rep[ taps[dels[del][i]][j]  ]; 
                 k < envs_len[ecos_vol[ taps[dels[del][i]][j]  ]];
                 k += ecos_rep[ taps[dels[del][i]][j]  ]) {
               //  //printf("	pos k = %d\n", k);

                 // comment garantir envs_cal a eco_len
                 vol = 
                 envs_cal[  ecos_vol[ taps[dels[del][i]][j]  ]   ][k]
                 /
                 envs_cal[  ecos_vol[ taps[dels[del][i]][j]  ]   ][0];
                // //printf("	vol=%f\n", vol);
                 if (vol > 8) vol = 8;
                 if (vol < 0) vol = 0;

                 pan = 1;
                 if (ecos_pan[ taps[dels[del][i]][j]  ] > 1) {
                     if (k < envs_len[ecos_pan[ taps[dels[del][i]][j]  ]])
                     pan = envs_cal[ecos_pan[ taps[dels[del][i]][j]  ]][k] / b321 * 2;
                     else
                     pan = envs_cal[ecos_pan[ taps[dels[del][i]][j]  ]][  envs_len[ecos_pan[ taps[dels[del][i]][j]  ]]  - 1  ] / b321 * 2;
                 }
                // //printf("	pan ok\n");

                 // il faut longueur de tap ici !
              //   //printf("	for (l = 0; l < %d; l++) {\n", tap_len);
//
                 for (l = 0; l < tap_len; l++) {
                     eco_l[i][j][l + k] = eco_l[i][j][l + k] + tap_l[l] * vol * (2 - pan);
                     eco_r[i][j][l + k] = eco_r[i][j][l + k] + tap_r[l] * vol * pan;
                 }
              //   //printf("	}\n	cal ok\n");
            }
            k -= ecos_rep[ taps[dels[del][i]][j]  ];
            if (ecos_len < (k + tap_len)  )
                ecos_len = (k + tap_len);
            ////printf("	fin traitement tap %d j=%d\n", taps_cnt[dels[del][i]], j);
        }
        tap_len = ecos_len;



        for (m = 0; m < dst_len; m++) {
            del_l[m] = 0;
            del_r[m] = 0;
        }
        // cumul dans le tape pour etre reutilisé
        for (j = 0; j < taps_cnt[dels[del][i]] ; j++) {
            //for (m = 0; m < tap_len; m++) {
            for (m = 0; m < dst_len; m++) {
                del_l[m] = del_l[m] + eco_l[i][j][m];
                del_r[m] = del_r[m] + eco_r[i][j][m];
            }
            //printf("	go to free\n");
            free(eco_l[i][j]);
            free(eco_r[i][j]);
            //printf("	free ok\n");
        }

            //printf("copie tap in del\n");
        for (m = 0; m < dst_len; m++) {
            tap_l[m] = tap_l[m] + del_l[m];
            tap_r[m] = tap_r[m] + del_r[m];
        }
            //printf("free eco\n");


        free(eco_l[i]);
        free(eco_r[i]);
            //printf("free ok\n");
    }
            //printf("copie del in src\n");
    for (i = 0; i < dst_len; i++) {
        src_l[i] = tap_l[i];
        src_r[i] = tap_r[i];
    }
            //printf("free eco ...\n");
    free(eco_l);
    free(eco_r);
            //printf("free tap l ...\n");
    free(tap_l);
            //printf("free tap r ...\n");
    free(tap_r);
            //printf("free del ...\n");
    free(del_l);
    free(del_r);
            //printf("libération del_cal ok\n");
}


void fil_cal(
  double *src_l,
  double *src_r,
  uint32_t src_len,
  uint8_t fil_,
  uint8_t *fils_fil,
  uint8_t *fils_cut,
  uint8_t *fils_res,
  uint8_t *fils_app,
  double **envs_cal,
  uint32_t *envs_len,
  double b321
) {
    //printf("FIL_CAL\n");
    uint32_t i;

    //double drive = 0;//internal distortion 0 to 0.1

    double cut;
    double res;//resonance 0 to 1; 
    double frq;
    double dmp;


    // Low = 1 High = 2 Band = 3 Notch = 4
    double fil[5];
    fil[0] = 0;
    fil[1] = 0 ;//Low pass output 
    fil[2] = 0;// High pass output 
    fil[3] = 0;// Band pass output 
    fil[4] = 0; //Notch output 

    //double peak = fil[1] - fil[2];
    //if (fils_app[fil_] > 0) {
        double *dst_l, *dst_r;
        dst_l = (double *)malloc(sizeof(double) * src_len);
        dst_r = (double *)malloc(sizeof(double) * src_len);
    //}

    for (i = 1; i < src_len; i++) {

        if (i < envs_len[fils_cut[fil_]])      
        cut = envs_cal[fils_cut[fil_]][i];
        else
        cut = envs_cal[fils_cut[fil_]][  envs_len[fils_cut[fil_]]  -  1   ];

        if (i < envs_len[fils_res[fil_]])      
        res = envs_cal[fils_res[fil_]][i] / b321;
        else
        res = envs_cal[fils_res[fil_]][  envs_len[fils_res[fil_]]  -  1   ] / b321;


        frq = sin(2 * PI * cut / RATE); // the fs*2 is because it's double sampled
        dmp = MIN(2.0 * (1.0 - pow(res, 0.25)), MIN(2.0, 2.0 / frq - frq * 0.5));

        fil[4] = src_l[i] - dmp * fil[3];
        fil[1] = fil[1] + frq * fil[3];
        fil[2] = fil[4] - fil[1];
        fil[3] = frq * fil[2] + fil[3];// - drive * fil[3] * fil[3] * fil[3];
        if (fils_app[fil_] > 0)
        dst_l[i] =  fil[fils_fil[fil_]];
        else
        src_l[i] =  fil[fils_fil[fil_]];
    }

    fil[1] = 0 ;//Low pass output 
    fil[2] = 0;// High pass output 
    fil[3] = 0;// Band pass output 
    fil[4] = 0; //Notch output 
    //peak = fil[1] - fil[2];
    for (i = 1; i < src_len; i++) {

        //cut = envs_cal[fils_cut[fil_]][i];
        //res = envs_cal[fils_res[fil_]][i] / b321;

        if (i < envs_len[fils_cut[fil_]])      
        cut = envs_cal[fils_cut[fil_]][i];
        else
        cut = envs_cal[fils_cut[fil_]][  envs_len[fils_cut[fil_]]  -  1   ];

        if (i < envs_len[fils_res[fil_]])      
        res = envs_cal[fils_res[fil_]][i] / b321;
        else
        res = envs_cal[fils_res[fil_]][  envs_len[fils_res[fil_]]  -  1   ] / b321;




        frq = sin(2 * PI * cut / RATE); // the fs*2 is because it's double sampled
        dmp = MIN(2.0 * (1.0 - pow(res, 0.25)), MIN(2.0, 2.0 / frq - frq * 0.5));

        fil[4] = src_r[i] - dmp * fil[3];
        fil[1] = fil[1] + frq * fil[3];
        fil[2] = fil[4] - fil[1];
        fil[3] = frq * fil[2] + fil[3];// - drive * fil[3] * fil[3] * fil[3];
        if (fils_app[fil_] > 0)
        dst_r[i] =  fil[fils_fil[fil_]];
        else
        src_r[i] =  fil[fils_fil[fil_]];
    }
    if (fils_app[fil_] == 1) {
        for (i = 1; i < src_len; i++) {
            src_l[i] = src_l[i] + dst_l[i];
            src_r[i] = src_r[i] + dst_r[i];
        }
    }
    if (fils_app[fil_] == 2) {
        for (i = 1; i < src_len; i++) {
            src_l[i] = src_l[i] - dst_l[i];
            src_r[i] = src_r[i] - dst_r[i];
        }
    }
    free(dst_l);
    free(dst_r);

}

int main (int argc, char*argv[]) {


    ////printf("size of uint8_t : %f\n", sizeof(uint8_t));
    ////printf("size of uint16_t : %f\n", sizeof(uint16_t));
    ////printf("size of uint32_t : %f\n", sizeof(uint32_t));
    ////printf("size of double : %f\n", sizeof(double));

    uint32_t a, i, j, k, l, m, n, o, p, q, z;
    double f,t;
    double pha,phd, phz, fq_, ofq_, ops, odi, ori, pho, phs, dps, pts, ofq, frq, fpi, osc, vol, pan, puw, pch, sat, del, fil;
    uint32_t b321 = 2147483647;
    // double b321 = 4294967295;
     //printf("  %d \n", b321);
//    return 0;

    uint8_t r = 1;

/*
    uint8_t *music_data = NULL;
    long music_file_length;
    FILE *music_file = fopen (argv[1], "rb");

    if (music_file != NULL) {
        fseek(music_file, 0, SEEK_END);
        music_file_length = ftell(music_file);
        fseek(music_file, 0, SEEK_SET);
        music_data = M8(music_file_length);
        //PIK("music_data");
        //MIK(music_data);

        //if (music_data == NULL) 
            //printf("error: no allocation of memory (for file loading).\n");
        //else 
        if (music_data != NULL) 
            fread(music_data, 1, music_file_length, music_file);
        fclose(music_file);
    }
    else {
        //printf("error: no file.\n");
    }
*/

#include "data.c"


    if (!(music_data[0] == 75 && music_data[1] == 73 && music_data[2] == 77)) {
        //printf("error: bad file (empty or format).\n");
    }

    //printf("music_data\n");
    //printmem8(music_data, music_file_length);


    // NOTES FREQUENCY
    double note2freq[88];
    note2freq[0] = 27.5;
    for (i = 1; i < 88; i++) {
        note2freq[i] = note2freq[i - 1] * 1.059463094359295264;
        ////printf("%d %f\n", i, note2freq[i]);
    }


    uint32_t music_seek = 0;

    uint32_t kim1 = G32;

    uint8_t envs_ = G8;
    uint8_t envs_cnt[envs_];
    uint32_t envs_len[envs_];
    uint32_t *envs_key[envs_];
    uint32_t *envs_val[envs_];
    for (i = 0; i < envs_; i++) {
        envs_cnt[i] = G8;
        envs_key[i] = M32(envs_cnt[i]);
        //printf("envs_key[%d]\n", i);
        //PIK("envs_key[i]");
        //MIK(envs_key[i]);

        envs_val[i] = M32(envs_cnt[i]);
        //printf("envs_val[%d]\n", i);
        //PIK("envs_val[i]");
        //MIK(envs_val[i]);
        for (j = 0; j < envs_cnt[i]; j++) {
             envs_key[i][j] = G32;
             envs_val[i][j] = G32;
             envs_len[i] = envs_key[i][j] + 1;
        }
        //printf("envs_key[%d]\n", i);
        //printmem32(envs_key[i], envs_cnt[i]);
        //printf("envs_val[%d]\n", i);
        //printmem32(envs_val[i], envs_cnt[i]);
    }

    //printf("ENVS\n");
    for (i = 0; i < envs_; i++) {
        //printf("%d :: nb %d\n", i, envs_cnt[i]);
        for (j = 0; j < envs_cnt[i]; j++) {
            //printf("[%d][%d] %d :: %d\n", i, j, envs_key[i][j], envs_val[i][j]);
        }
    
    }


    double kin, kal, kim;
    double *envs_cal[envs_];
    //printf("ENVS :: envs_cal\n");
    for (i = 0; i < envs_; i++) {
        l = envs_cnt[i] - 1;
        //printf("size envs_len[i] = %d\n", envs_len[i]);
        envs_cal[i] = (double *)malloc(sizeof(double) * envs_len[i]);
        //printf("envs_cal[%d] (%d)\n", i, envs_len[i]);
        //PIK("envs_cal[i]");
        //MIK(envs_cal[i]);
        //printf("for (j = 0; j < %d; j++) { //envs_cnt[%d]=%d\n", l, i, envs_cnt[i]);
        for (j = 0; j < l; j++) {
            //printf("envs_cal[%d] <- envs[%d]\n", i, i);
            //printf("for (k = %d; k < %d; k++) {\n", envs_key[i][j], envs_key[i][j + 1]);
            for (k = envs_key[i][j]; k <= envs_key[i][j + 1]; k++) {
//                if (k < 16) 
////printf("envs_cal[%d][%d] <- envs[%d][%d] à envs[%d][%d]\n", i, k, i, j, i, j + 1);
                kin = k - envs_key[i][j];
////printf("kin %f\n", kin);
                kal = envs_key[i][j + 1] - envs_key[i][j];
////printf("kal %f\n", kal);
                kim = kin / kal;
////printf("kim %f\n", kim);
                envs_cal[i][k] = (double)envs_val[i][j] + ((double)envs_val[i][j + 1] - (double)envs_val[i][j]) * kim;
////printf("envs_cals[][] %f\n", envs_cal[i][k]);

            }

        }
        //printf("envs_cal[%d] (%d)\n", i,  envs_len[i]);
        //printmemdb(envs_cal[i], envs_len[i]);
    }
    for (i = 0; i < envs_; i++) {
        free(envs_key[i]);
        free(envs_val[i]);
    }

    uint8_t fils_ = G8;
    uint8_t fils_fil[fils_];
    uint8_t fils_cut[fils_];
    uint8_t fils_res[fils_];
    uint8_t fils_app[fils_];
    for (i = 0; i < fils_; i++) {
        fils_fil[i] = G8;
        fils_cut[i] = G8;
        fils_res[i] = G8;
        fils_app[i] = G8;
    }
    //printf("FILS\n");
    for (i = 0; i < fils_; i++) {
        //printf("%d fil:%d cut:%d res:%d\n", i, fils_fil[i], fils_cut[i], fils_res[i]);
    }

    uint8_t equs_ = G8;
    uint8_t equs_cnt[equs_];
    uint8_t *equs[equs_];
    for (i = 0; i < equs_; i++) {
        equs_cnt[i] = G8;
        equs[i] = M8(equs_cnt[i]);
        //PIK("equs[i]");
        //MIK(equs[i]);

        for (j = 0; j < equs_cnt[i]; j++) {
            equs[i][j] = G8;
        }
        //printf("equs[%d] (%d)\n", i, equs_cnt[i]);
        //printmem8(equs[i], equs_cnt[i]);
    }
    //printf("EQUS\n");
    for (i = 0; i < equs_; i++) {
        //printf("%d :: nb %d\n", i, equs_cnt[i]);
        for (j = 0; j < equs_cnt[i]; j++) {
             //printf("[%d][%d] = %d\n", i, j, equs[i][j]);
        }
    }


    uint8_t ecos_ = G8;
    uint32_t ecos_rep[ecos_];
    uint8_t ecos_vol[ecos_];
    uint8_t ecos_pan[ecos_];
    for (i = 0; i < ecos_; i++) {
        ecos_rep[i] = G32;
        ecos_vol[i] = G8;
        ecos_pan[i] = G8;
    }
    //printf("ECOS\n");
    for (i = 0; i < fils_; i++) {
        //printf("%d rep:%d vol:%d pan:%d\n", i, ecos_rep[i], ecos_vol[i], ecos_pan[i]);
    }


    uint8_t taps_ = G8;
    uint8_t taps_cnt[taps_];
    uint8_t *taps[taps_];
    for (i = 0; i < taps_; i++) {
        taps_cnt[i] = G8;
        taps[i] = M8(taps_cnt[i]);
        //PIK("taps[i]");
        //MIK(taps[i]);

        for (j = 0; j < taps_cnt[i]; j++) {
            taps[i][j] = G8;
        }
        //printf("taps[%d] (%d)\n", i, taps_cnt[i]);
        //printmem8(taps[i], taps_cnt[i]);
    }
    //printf("TAPS\n");
    for (i = 0; i < taps_; i++) {
        //printf("%d :: nb %d\n", i, taps_cnt[i]);
        for (j = 0; j < taps_cnt[i]; j++) {
             //printf("[%d][%d] = %d\n", i, j, taps[i][j]);
        }
    }


    uint8_t dels_ = G8;
    uint8_t dels_cnt[dels_];
    uint8_t *dels[dels_];
    for (i = 0; i < dels_; i++) {
        dels_cnt[i] = G8;
        dels[i] = M8(dels_cnt[i]);
        //PIK("dels[i]");
        //MIK(dels[i]);

        for (j = 0; j < dels_cnt[i]; j++) {
            dels[i][j] = G8;
        }
        //printf("dels[%d] (%d)\n", i, dels_cnt[i]);
        //printmem8(dels[i], dels_cnt[i]);
    }
    //printf("DELS\n");
    for (i = 0; i < dels_; i++) {
        //printf("%d :: nb %d\n", i, dels_cnt[i]);
        for (j = 0; j < dels_cnt[i]; j++) {
             //printf("[%d][%d] = %d\n", i, j, dels[i][j]);
        }
    }


    uint8_t oscs_ = G8;
    uint8_t oscs_osc[oscs_];
    uint8_t oscs_pch[oscs_];
    uint8_t oscs_puw[oscs_];
    uint8_t oscs_sat[oscs_];
    uint8_t oscs_vol[oscs_];
    uint8_t oscs_pan[oscs_];
    uint8_t oscs_fil[oscs_];
    uint8_t oscs_del[oscs_];
    for (i = 0; i < oscs_; i++) {
        oscs_osc[i] = G8;
        oscs_pch[i] = G8;
        oscs_puw[i] = G8;
        oscs_sat[i] = G8;
        oscs_vol[i] = G8;
        oscs_pan[i] = G8;
        oscs_fil[i] = G8;
        oscs_del[i] = G8;
    }
    /*
    //printf("OSCS\n");
    for (i = 0; i < oscs_; i++) {
        //printf("%d osc:%d pch:%d puw:%d sat:%d vol:%d pan:%d fil:%d del:%d\n", 
        i,
        oscs_osc[i],
        oscs_pch[i],
        oscs_puw[i],
        oscs_sat[i],
        oscs_vol[i],
        oscs_pan[i],
        oscs_fil[i],
        oscs_del[i]);
    }
*/

    uint8_t inss_ = G8;
    uint8_t inss_cnt[inss_];
    uint8_t *inss[inss_];
    for (i = 0; i < inss_; i++) {
        inss_cnt[i] = G8;
        inss[i] = M8(inss_cnt[i]);
        //PIK("inss[i]");
        //MIK(inss[i]);

        for (j = 0; j < inss_cnt[i]; j++) {
            inss[i][j] = G8;
        }
        //printf("inss[%d] (%d)\n", i, inss_cnt[i]);
        //printmem8(inss[i], inss_cnt[i]);
    }
    //printf("INSS\n");
    for (i = 0; i < inss_; i++) {
        //printf("%d :: nb %d\n", i, inss_cnt[i]);
        for (j = 0; j < inss_cnt[i]; j++) {
             //printf("[%d][%d] = %d\n", i, j, inss[i][j]);
        }
    }

    uint8_t syns_ = G8;
    uint32_t syns_len[syns_];
    uint8_t syns_fil[syns_];
    uint8_t syns_del[syns_];
    for (i = 0; i < syns_; i++) {
        syns_fil[i] = G8;
        syns_del[i] = G8;
    }
    //printf("SYNS\n");
    for (i = 0; i < syns_; i++) {
        //printf("%d fil:%d del:%d\n", i, syns_fil[i], syns_del[i]);
    }

    uint32_t trks_len[syns_];
/*
    uint8_t trks_ = G8;
    uint8_t trks_vol[trks_];
    uint8_t trks_pan[trks_];
    uint8_t trks_fil[trks_];
    uint8_t trks_del[trks_];
    for (i = 0; i < trks_; i++) {
        trks_vol[i] = G8;
        trks_pan[i] = G8;
        trks_fil[i] = G8;
        trks_del[i] = G8;
    }
    //printf("TRKS\n");
    for (i = 0; i < trks_; i++) {
        //printf("%d vol:%d pan:%d fil:%d del:%d\n", i, trks_vol[i], trks_pan[i], trks_fil[i], trks_del[i]);
    }
*/

    // nombre de pattern
    uint8_t pats_ = G8;
    // nombre de notes distinctes par pattern
    uint8_t pats_cnt[pats_];
    uint32_t pats_len[pats_];
    // valeures de la note du pattern/note qui va contenir les endroits
    uint8_t *pats_nots_val[pats_];
        // nombre de notes
    uint8_t *pats_nots_cnt[pats_];
        // notes
    uint32_t **pats_nots_key[pats_];
    for (i = 0; i < pats_; i++) {
        //printf("PATS i=%d\n", i); 
        // nombre de notes distinctes du pattern
        pats_cnt[i] = G8;
        pats_len[i] = 0;
        //printf("beginpat pats_cnt[%d]\n", pats_cnt[i]);
        //printf("beginpat pats_len[%d]\n", pats_len[i]);
        // note a stocker
        pats_nots_val[i] = M8(pats_cnt[i]);
        //PIK("pats_nots_val[i]");
        //MIK(pats_nots_val[i]);

        // nombre de notes
        pats_nots_cnt[i] = M8(pats_cnt[i]);
        //PIK("pats_nots_cnt[i]");
        //MIK(pats_nots_cnt[i]);

        // notes
        pats_nots_key[i] = (uint32_t **)malloc(sizeof(uint32_t *) * pats_cnt[i]);
        //PIK("pats_nots_key[i]");
        //MIK(pats_nots_key[i]);
        // but : afficher les adresses de ce ponteur qui est un tableau de pointeurs

        //printf("for (j = 0; j < %d; j++) {\n", pats_cnt[i]);
        for (j = 0; j < pats_cnt[i]; j++) {
           //printf("	j=%d\n", i); 
            pats_nots_key[i][j] = NULL;
            // note a stocker car G8 est appelée
            pats_nots_val[i][j] = G8;
            //printf("	pats_nots_val[%d][%d]=%d\n", i, j, pats_nots_val[i][j]);
            // nombre de notes (pour le pattern/note)
            pats_nots_cnt[i][j] = G8;
            //printf("	pats_nots_cnt[%d][%d]=%d\n", i, j, pats_nots_cnt[i][j]);
            // pointeur M32 de size nombre de notes
            //printf("	PREBUG preinit pointeurs pats_nots_key[%d][%d] (%d)\n", i, j, pats_nots_cnt[i][j]);
            pats_nots_key[i][j] = M32(pats_nots_cnt[i][j]);
            //printf("	POSTBUG pats_nots_key[%d][%d] (%d)\n", i, j, pats_nots_cnt[i][j]);
            //PIK("pats_nots_key[i][j]");
            //MIK(pats_nots_key[i][j]);

            //printf("	for (k = 0; k < %d; k++) {\n", pats_nots_cnt[i][j]);
            for (k = 0; k < pats_nots_cnt[i][j]; k++) {
                // stockage 32 bits de la note
                //printf("		k=%d\n", k);
                pats_nots_key[i][j][k] = G32;
                //printf("		pats_nots_key[%d][%d][%d] = %d\n", i, j, k, pats_nots_key[i][j][k]);
                //printf("		if pats_len[%d](=%d) < ...\n", i, pats_len[i]);
                if (pats_len[i] < pats_nots_key[i][j][k])
                    pats_len[i] = pats_nots_key[i][j][k];
                //printf("		pats_len[%d]=%d\n", i, pats_len[i]);
            }
            //printf("	}\n	pats_nots_key[%d]|%d] (%d)\n", i, j, pats_nots_cnt[i][j]);
            //printmem32(pats_nots_key[i][j], pats_nots_cnt[i][j]);
        }
        ////printmem32(pats_nots_key[i], pats_cnt[i]);
        //printf("}\npats_nots_key[%d] (%d)\n", i, pats_cnt[i]);
        //printdmem32(pats_nots_key[i], pats_cnt[i]); 
        //printf("finalpat pats_nots_cnt[%d] (%d)\n", i, pats_cnt[i]);
        //printmem8(pats_nots_cnt[i], pats_cnt[i]);
        //printf("finalpat pats_nots_val[%d] (%d)\n", i, pats_cnt[i]);
        //printmem8(pats_nots_val[i], pats_cnt[i]);
        //printf("finalpat pats_len[%d]\n", pats_len[i]);
    }


    //printf("PATS\n");
    for (i = 0; i < pats_; i++) {
        //printf("pat %d cnt %d len %d\n", i, pats_cnt[i], pats_len[i]);
        for (j = 0; j < pats_cnt[i]; j++) {
            //printf("pat[%d][%d] not:%d cnt:%d\n", i, j, pats_nots_val[i][j], pats_nots_cnt[i][j]);
            for (k = 0; k < pats_nots_cnt[i][j]; k++) {
                //printf("pat[%d][%d][%d]=%d\n", i,j,k,pats_nots_key[i][j][k]);
            }
        }
    }


   
    // nombre de mixs
    uint8_t mixs_ = G8;
    uint8_t mixs_cnt[mixs_];
    uint32_t mixs_len[mixs_];
    uint8_t *mixs_pats_val[mixs_];
    uint8_t *mixs_pats_cnt[mixs_];
    uint32_t **mixs_pats_key[mixs_];
    for (i = 0; i < mixs_; i++) {
        //printf("MIXS %d\n", i);
        mixs_cnt[i] = G8;
        //printf("mixs_cnt[%d]=%d\n", i, mixs_cnt[i]);
        mixs_len[i] = 0;
        //printf("mixs_len[%d]=%d\n", i, mixs_len[i]);
        mixs_pats_val[i] = M8(mixs_cnt[i]);
        //printf("mixs_pats_val[%d] (%d)\n", i, mixs_cnt[i]);
        //PIK("mixs_pats_val[i]");
        //MIK(mixs_pats_val[i]);

        mixs_pats_cnt[i] = M8(mixs_cnt[i]);
        //PIK("mixs_pats_cnt[i]");
        //MIK(mixs_pats_cnt[i]);

        mixs_pats_key[i] = (uint32_t **)malloc(sizeof(uint32_t *) * mixs_cnt[i]);
        //PIK("mixs_pats_key[i]");
        //MIK(mixs_pats_key[i]);

        //printf("for (j = 0; j < %d; j++) {\n", mixs_cnt[i]);
        for (j = 0; j < mixs_cnt[i]; j++) {
            //printf("	j=%d\n", j);
            mixs_pats_val[i][j] = G8;
            //printf("	mixs_pats_val[%d][%d]=%d\n", i, j, mixs_pats_val[i][j]);
            mixs_pats_cnt[i][j] = G8;
            //printf("	mixs_pats_cnt[%d][%d]=%d\n", i, j, mixs_pats_cnt[i][j]);
            mixs_pats_key[i][j] = M32(mixs_pats_cnt[i][j]);
            //printf("	mixs_pats_key[%d][%d] (%d)\n", i, j, mixs_pats_cnt[i][j]);
            //PIK("mixs_pats_key[i][j]");
            //MIK(mixs_pats_key[i][j]);
            
            //printf("	for (k = 0; k < %d; k++) {\n", mixs_pats_cnt[i][j]);
            for (k = 0; k < mixs_pats_cnt[i][j]; k++) {
                //printf("		k=%d\n", j);
                mixs_pats_key[i][j][k] = G32;
                //printf("mixs_pats_key[%d][%d][%d]=%d\n", i, j, k, mixs_pats_key[i][j][k]);
                //printf("		if mixs_len[%d](=%d) < ...\n", i, mixs_len[i]);
                if (mixs_len[i] < mixs_pats_key[i][j][k])
                    mixs_len[i] = mixs_pats_key[i][j][k];
                //printf("		mixs_len[%d]=%d\n", i, mixs_len[i]);
            }
            //printf("	}\n	mixs_pats_key[%d]|%d] (%d)\n", i, j, mixs_pats_cnt[i][j]);
            //printmem32(mixs_pats_key[i][j], mixs_pats_cnt[i][j]);
        }
        //printf("}\nmixs_patss_key[%d] (%d)\n", i, mixs_cnt[i]);
        //printdmem32(mixs_pats_key[i], mixs_cnt[i]); 
        //printf("finalmix mixs_pats_cnt[%d] (%d)\n", i, mixs_cnt[i]);
        //printmem8(mixs_pats_cnt[i], mixs_cnt[i]);
        //printf("finalmix mixs_pats_val[%d] (%d)\n", i, mixs_cnt[i]);
        //printmem8(mixs_pats_val[i], mixs_cnt[i]);
    }

    //printf("MIXS\n");
    for (i = 0; i < mixs_; i++) {
        //printf("mix %d cnt %d len %d\n", i, mixs_cnt[i], mixs_len[i]);
        for (j = 0; j < mixs_cnt[i]; j++) {
            //printf("mix[%d][%d] pat:%d cnt:%d\n", i, j, mixs_pats_val[i][j], mixs_pats_cnt[i][j]);
            for (k = 0; k < mixs_pats_cnt[i][j]; k++) {
                //printf("mix[%d][%d][%d]=%d\n", i,j,k,mixs_pats_key[i][j][k]);
            }
        }
    }


    //printf("\n");
    //printf("\n");
    //printf("\n");


    // tableau notes distinctes par instruments
    uint32_t music_len = 0;
    uint32_t music_len_ = 0;
    uint32_t music_len__ = 0;
    uint32_t pats_max = 0;
    int8_t nots_cal[mixs_][88];
    uint8_t nots_cnt[mixs_];
    uint32_t nots_len[mixs_];
    uint32_t del__len;
    uint32_t inss_del_len[mixs_];
    uint32_t oscs_del_len[oscs_];
    uint8_t oscs_del_cal[oscs_];
    double *music_l;
    double *music_r;
    double *music_i_l[mixs_];
    double *music_i_r[mixs_];
    double **music_in_l[mixs_];
    double **music_in_r[mixs_];
    double ***music_ino_l[mixs_];
    double ***music_ino_r[mixs_];
    for (i = 0; i < oscs_; i++) oscs_del_cal[i] = 0;
    // scan des pistes instrumentése
    for (i = 0; i < mixs_; i++) {
        // i = index instrument en cours de traitement
        //printf("PISTE INSTRUMENTALE %d : NOMBRE DE PATTERN %d;\n", i, mixs_cnt[i]);
        for (j = 0; j < 88; j++) {
            nots_cal[i][j] = -1;
        }
        nots_len[i] = 0;
        inss_del_len[i] = 0;
        //printf("scan des osc pour trouver le plug long: %d osc a scanner;\n", inss_cnt[i]);
        for (l = 0; l < inss_cnt[i]; l++) {
            //printf("ins[%d][%d]=%d <- osc, vol=%d env_len=%d\n", i, l, inss[i][l], oscs_vol[inss[i][l]], envs_len[oscs_vol[inss[i][l]]]  );
            if (nots_len[i] < envs_len[oscs_vol[inss[i][l]]]) 
                nots_len[i] = envs_len[oscs_vol[inss[i][l]]];


            del__len = 0;
            if (oscs_del_cal[ inss[i][l]  ] == 0) {
                if (oscs_del[inss[i][l]] > 0) 
                del__len = del_len(oscs_del[inss[i][l]], envs_len[oscs_vol[inss[i][l]]],
                           envs_len, dels, dels_cnt, taps, taps_cnt, ecos_, ecos_rep, ecos_vol);

                oscs_del_len[inss[i][l]] = del__len;
                oscs_del_cal[ inss[i][l]  ] = 1;
            }
            else del__len = oscs_del_len[inss[i][l]];

            if (inss_del_len[i] < del__len) 
                inss_del_len[i] = del__len;
    

            if (inss_del_len[i] < nots_len[i])
                inss_del_len[i] = nots_len[i];


            // calcul du delai instrument ici ?
            // risque de besoin pour music_i music_in
        }
        //printf("LONGUEUR INSTRUMENT : longueur osc le plus long %d;\n", nots_len[i]);
        //printf("DELAIS INSTRUMENT SANS DELAIS (osc avec delais): delais osc le plus long %d;\n", inss_del_len[i]);
        syns_len[i] = inss_del_len[i];

        if (syns_del[i] > 0) 
            syns_len[i] = del_len(syns_del[i], inss_del_len[i],
                                  envs_len, dels, dels_cnt, taps, taps_cnt, ecos_, ecos_rep, ecos_vol);
 
        //printf("DELAIS INSTRUMENT APRES DELAIS : delais osc le plus long %d;\n", syns_len[i]);
 

        nots_cnt[i] = 0;
        for (j = 0; j < mixs_cnt[i]; j++) {
            //printf("mix[%d][%d] ::  PATTERN %d : NOMBRE DE NOTES :%d\n", i, j, mixs_pats_val[i][j], mixs_pats_cnt[i][j]);
            for (k = 0; k < pats_cnt[mixs_pats_val[i][j]]; k++) {
                //printf("note du pattern en cours de scan : %d\n", pats_nots_val[mixs_pats_val[i][j]][k]);
                if (nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][k]] == -1) {
                    //printf(" ... calcul\n");
                    nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][k]] = nots_cnt[i];
                    nots_cnt[i]++;
                }
            }
        }// fin scan des patterns de la piste instrumentée pour connaitre le nombre de notes distinctes et pouvoir créer le tableau
        //printf("Initialisation des ptr multi avec %d notes\n", nots_cnt[i]);
        //printf("gauche instru.note\n");
        music_in_l[i] = (double **)malloc(sizeof(double *) * nots_cnt[i]);
        //printf("droite instru.note\n");
        music_in_r[i] = (double **)malloc(sizeof(double *) * nots_cnt[i]);
        //printf("gauche instru.note.osc\n");
        music_ino_l[i] = (double ***)malloc(sizeof(double **) * nots_cnt[i]);
        //printf("droite instru.note.osc\n");
        music_ino_r[i] = (double ***)malloc(sizeof(double **) * nots_cnt[i]);
        //printf("ptr multis initialisés\n");
        // scan des notes calculées
        //printf("\nSCAN DES NOTES A CALCULER DE L INSTRUMENT !\n");
        for (j = 0; j < 88; j++) {
            if (nots_cal[i][j] > -1) {
                //printf("calcul de la note (ino) %d\n", j);
                music_ino_l[i][ nots_cal[i][j]  ] = (double **)malloc(sizeof(double *) * inss_cnt[i]);
                music_ino_r[i][ nots_cal[i][j]  ] = (double **)malloc(sizeof(double *) * inss_cnt[i]);
                //printf(" parcours des oscillos (%d oscs);\n", inss_cnt[i]);
                for (l = 0; l < inss_cnt[i]; l++) {

                    music_ino_l[i][ nots_cal[i][j] ][l] = (double *)malloc(sizeof(double) * inss_del_len[i]  );
                    music_ino_r[i][ nots_cal[i][j] ][l] = (double *)malloc(sizeof(double) * inss_del_len[i]  );
                    for (m = 0; m <  inss_del_len[i]  ; m++) {
                        music_ino_l[i][nots_cal[i][j]][l][m] = 0;
                        music_ino_r[i][nots_cal[i][j]][l][m] = 0;
                    }



                         // pch
                         // puw
                         // sat
                    t = 0;
                    //printf("osc est type %d\n", oscs_osc[inss[i][l]]);
                    for (m = 0; m < envs_len[oscs_vol[inss[i][l]]]; m++) {
                        if (oscs_puw[inss[i][l]] > 0) {
                            if (m < envs_len[oscs_puw[inss[i][l]]])    
                            puw = envs_cal[oscs_puw[inss[i][l]]][m] / b321;
                            else
                            puw = envs_cal[oscs_puw[inss[i][l]]][  envs_len[oscs_puw[inss[i][l]]] - 1  ] / b321;
                        }
                        else
                            puw = 0;

                        if (oscs_pan[inss[i][l]] > 0) {
                            if (m < envs_len[oscs_pan[inss[i][l]]])    
                            pan = envs_cal[oscs_pan[inss[i][l]]][m] / b321 * 2;
                            else
                            pan = envs_cal[oscs_pan[inss[i][l]]][  envs_len[oscs_pan[inss[i][l]]] - 1  ] / b321 * 2;
                        }
                        else
                            pan = 1;

                        if (oscs_sat[inss[i][l]] > 0) {
                            if (m < envs_len[oscs_sat[inss[i][l]]])    
                            sat = envs_cal[oscs_sat[inss[i][l]]][m] / b321;
                            else
                            sat = envs_cal[oscs_sat[inss[i][l]]][  envs_len[oscs_sat[inss[i][l]]] - 1  ] / b321;
                        }
                        else
                            sat = 1;

                        f = (double)m;



                        if (oscs_pch[inss[i][l]] > 0) {
                            if (m < envs_len[oscs_pch[inss[i][l]]])    
                            pch = envs_cal[oscs_pch[inss[i][l]]][m] / 268435455;
                            else
                            pch = envs_cal[oscs_pch[inss[i][l]]][  envs_len[oscs_pch[inss[i][l]]] - 1  ] / 268435455;
                            t += pch;

                            frq = t * note2freq[j] / RATE;
                            pho = (frq - floor(frq));
                            fpi = frq * 2 * PI;

                        }
                        else {
                            pch = 1;
                            frq = f * note2freq[j] / RATE;
                            pho = (frq - floor(frq));
                            fpi = frq * 2 * PI;
                        }
                        switch (oscs_osc[inss[i][l]]) {
                        // sin cos
                        case 1:
                            osc = 
                                sin(fpi) * (1 - puw)
                                 +
                                cos(fpi) * puw;
                            break;
                        // saw tri
                        case 2:
                            if (pho >= puw) osc = 1 - ((pho - puw) / (1 - puw)) * 2;
                            else osc = (pho / puw) * 2 - 1;
                            break;
                        // sqr puw
                        case 3:
                            if (puw == 0) puw = 0.5;
                            if (pho < puw) osc = 1;
                            else osc = -1;
                            break;
                        // rien si pas de number ou pas de 
                        case 4:
                            //osc = sin(7*fpi * sin(5*fpi));
                            osc = 
                                  sin(7 * fpi * sin(5 * fpi)) * (1 - puw)
                                //sin(fpi * sin(fpi)) * (1 - puw)
                                 +
                                  cos(7 * fpi * cos(5 * fpi)) * puw;
                                //cos(fpi * cos(fpi)) * puw;
                            break;
                        default:
                        case 0:
                            break;
                        }
                        if (osc > sat) osc = sat;
                        if (-osc > sat) osc = -sat;

                        music_ino_l[i][nots_cal[i][j]][l][m] = osc * (2 - pan)
                        * envs_cal[oscs_vol[inss[i][l]]][m];

                        music_ino_r[i][nots_cal[i][j]][l][m] = osc * pan
                        * envs_cal[oscs_vol[inss[i][l]]][m];
                        

                    }

                    // fil
                    // del
                    // appel du delai avec la longueur de ? oscs_del_len ou dels_len
                    // les 2 sont nécéssaires car il devra parcourir la longueur d'origine et rendre un pointeur avec la longeur demandée
                    if (oscs_fil[inss[i][l]] > 0) {
                        for (m = 0; m < equs_cnt[   oscs_fil[inss[i][l]]   ]; m++) {
                            fil_cal(music_ino_l[i][nots_cal[i][j]][l], music_ino_r[i][nots_cal[i][j]][l],
                                    inss_del_len[i], equs[   oscs_fil[inss[i][l]]   ][m],
                                    fils_fil, fils_cut, fils_res, fils_app, envs_cal, envs_len, b321);
                        }
                    }

                    if (oscs_del[inss[i][l]] > 0)
                    del_cal(music_ino_l[i][nots_cal[i][j]][l], music_ino_r[i][nots_cal[i][j]][l],
                            envs_len[oscs_vol[inss[i][l]]], inss_del_len[i], oscs_del[inss[i][l]],
                            dels, dels_cnt, taps, taps_cnt, ecos_, ecos_rep, ecos_vol, ecos_pan, envs_cal, envs_len, b321);
 
                    
                }
                // addition des oscillo ramassés (cela doit tre fit apres car comme expliqué plus haut del fil individuel ...)
                //printf("music_in_[%d][%d] addition des osc sur un sample de longueur %d\n", i, nots_cal[i][j], inss_del_len[i]);
                music_in_l[i][ nots_cal[i][j] ] = (double *)malloc(sizeof(double) * syns_len[i]);

                //MIK(music_in_l[i][nots_cal[i][j]]);

                //printf(".\n");
                music_in_r[i][ nots_cal[i][j] ] = (double *)malloc(sizeof(double) * syns_len[i]);

                //printf("memoire sample prete\n");
                for (m = 0; m < syns_len[i]; m++) {
                    music_in_l[i][ nots_cal[i][j] ][m] = 0;
                    music_in_r[i][ nots_cal[i][j] ][m] = 0;
                }
                //printf("sample formatée\n");
                for (l = 0; l < inss_cnt[i]; l++) {
                    for (m = 0; m < inss_del_len[i]; m++) {
                         //if (m < 100)
                         ////printf("a_sample at %d\n", m);
                         music_in_l[i][ nots_cal[i][j] ][m] = 
                         music_in_l[i][ nots_cal[i][j] ][m] + music_ino_l[i][ nots_cal[i][j] ][l][m]; 
                         music_in_r[i][ nots_cal[i][j] ][m] = 
                         music_in_r[i][ nots_cal[i][j] ][m] + music_ino_r[i][ nots_cal[i][j] ][l][m]; 
                         //if (m < 100)
                         ////printf("z_sample at %d\n", m);
                    }
                         //printf("libération foireuse ? %d\n", l);
                    free(music_ino_l[i][ nots_cal[i][j]  ][l]);
                    free(music_ino_r[i][ nots_cal[i][j]  ][l]);
                }
                //printf("osc ajoutés dans sample\n");
                free(music_ino_l[i][ nots_cal[i][j]  ]);
                free(music_ino_r[i][ nots_cal[i][j]  ]);
                // si il y a des effets souhaités a mettre sur music_in c'est ici.
                    //printf("syns_fil[%d] = %d\n", i, syns_fil[i]);

                    if (syns_fil[i] > 0) {
                        for (m = 0; m < equs_cnt[   syns_fil[i]   ]; m++) {
                            //printf("equs[%d][%d] = %d\n", syns_fil[i], m, equs[   syns_fil[i]   ][m]);
                            fil_cal(music_in_l[i][nots_cal[i][j]], music_in_r[i][nots_cal[i][j]],
                                    syns_len[i], equs[   syns_fil[i]   ][m],
                                    fils_fil, fils_cut, fils_res, fils_app, envs_cal, envs_len, b321);
                        }
                    }


                    if (syns_del[i] > 0)
                    del_cal(music_in_l[i][nots_cal[i][j]], music_in_r[i][nots_cal[i][j]],
                            inss_del_len[i], syns_len[i], syns_del[i],
                            dels, dels_cnt, taps, taps_cnt, ecos_, ecos_rep, ecos_vol, ecos_pan, envs_cal, envs_len, b321);



            } // fin si note est a calculer
        } // fin des notes calculées, leur sample est désormais stocké
        free(music_ino_l[i]);
        free(music_ino_r[i]);

        //printf("longueur prepattern de la piste simple : %d\n", mixs_len[i]);
        //printf("Notes de l'instrument calculées (1 sample par note en mémoire)\n");
        //printf("but : créer la piste instrumentale\n");
        // choppe la pose la plus loin
        pats_max = 0;
        for (j = 0; j < mixs_cnt[i]; j++) {
            // on a mixs_len[i]
            // on addition pats_len[mixs_pats_val[i][j]] le plus haut
            for (k = 0; k < pats_cnt[mixs_pats_val[i][j]]; k++) {
                 if (pats_max < pats_len[mixs_pats_val[i][j]])
                     pats_max = pats_len[mixs_pats_val[i][j]];
            }
            // on a le point le plus loin, on incrémente la longueur de notre pattern
            // il faut rajouter la longueur de la derniere note du pattern
            // de plus il n'est pas du tout garantie que le pattern le plus long finisse en dernier
            // cela dépend de la longueur des notes qu'il y a dedans
            //printf("ML[%d] = %d + %d + %d\n", i, mixs_len[i], pats_max, inss_del_len[i]);
            //printf("ML...=%d\n", mixs_len[i]);
        }
       // printf("longueur syns : %d\n", syns_len[i]);
            mixs_len[i] = mixs_len[i] + pats_max + syns_len[i];

        // calcul longueur delais de trk
        trks_len[i] = mixs_len[i];
/*
        if (trks_del[i] > 0)
            trks_len[i] = del_len(trks_del[i], mixs_len[i],
                                  envs_len, dels, dels_cnt, taps, taps_cnt, ecos_, ecos_rep, ecos_vol);

*/
       // printf("longueur finale de la piste simple : %d\n", mixs_len[i]);
       // printf("longueur finale de la piste delais : %d\n", trks_len[i]);

        music_i_l[i] = (double *)malloc(sizeof(double) * trks_len[i]);
        music_i_r[i] = (double *)malloc(sizeof(double) * trks_len[i]);
        for (j = 0; j < trks_len[i]; j++) {
            music_i_l[i][j] = 0;
            music_i_r[i][j] = 0;
        }
        // the scan mix.pat
        //printf(" -- DEBUT DU MIX.PAT --\n");
        // scan des patterns dans la piste instrument
        for (j = 0; j < mixs_cnt[i]; j++) {
            ////printf("mix[%d][%d] ::  PATTERN %d : NOMBRE DE NOTES :%d\n", i, j, mixs_pats_val[i][j], mixs_pats_cnt[i][j]);
            // scan des clés du mixœ
            for (k = 0; k < mixs_pats_cnt[i][j]; k++) {
                //printf("mix[%d][%d][%d]=%d\n", i,j,k,mixs_pats_key[i][j][k]);
                // a chaque clé de mix, le pattern mics_pats_val[i][j] est scanné
                // scan des notes d'un pattern
                for (l = 0; l < pats_cnt[mixs_pats_val[i][j]]; l++) {
                    /*
                    //printf("pat[%d][%d] not:%d(%d) cnt:%d\n", mixs_pats_val[i][j], l, 
                                 pats_nots_val[mixs_pats_val[i][j]][l],

                     nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][l]],

                      pats_nots_cnt[mixs_pats_val[i][j]][l]);
                    */
                    //scan des clés de la note d un pattern
                    for (m = 0; m < pats_nots_cnt[mixs_pats_val[i][j]][l]; m++) {
  /*                       
                         //printf("mixpat[(instru)%d][(pattern)%d][(clémix)%d][(patnote)%d][(clépat)%d]=%d not:%d(%d) %d\n", i,j,k,l,m,pats_nots_key[mixs_pats_val[i][j]][l][m],
                                     pats_nots_val[mixs_pats_val[i][j]][l],
                         nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][l]],  // ce param est foireux quand plusieurs paterns ds un mix i ont la meme note
nots_cal[i][39]   
                      );
*/
                        a = mixs_pats_key[i][j][k] + pats_nots_key[mixs_pats_val[i][j]][l][m];
                        z = a + syns_len[i];
                        //printf("i %d j %d k %d l %d m %d a %d z %d\n", i,j,k,l,m,a, z);
                        //printf("music_len(resized?) %d\n", music_len);
                        for (n = a ; n < z; n++) {
                            music_i_l[i][n] = 
                            music_i_l[i][n] + 
                            music_in_l[i][ nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][l]]   ][ n - a ];
                            music_i_r[i][n] = 
                            music_i_r[i][n] + 
                            music_in_r[i][ nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][l]]   ][ n - a ];

                        }
                        //printf("end of in->i\n");
                    }
                }
            }
/*
                    if (trks_fil[i] > 0) {
                        for (m = 0; m < equs_cnt[   trks_fil[i]   ]; m++) {
                            fil_cal(music_i_l[i], music_i_r[i],
                                    trks_len[i], equs[   trks_fil[i]   ][m],
                                    fils_fil, fils_cut, fils_res, fils_app, envs_cal, envs_len, b321);
                        }
                    }

                    if (trks_del[i] > 0)
                    del_cal(music_i_l[i], music_i_r[i],
                            mixs_len[i], trks_len[i], trks_del[i],
                            dels, dels_cnt, taps, taps_cnt, ecos_, ecos_rep, ecos_vol, ecos_pan, envs_cal, envs_len, b321);
*/
                        if (music_len < trks_len[i])
                            music_len = trks_len[i];

        }// il faut rebelote j pour faire liberer correctement music_in_
        for (j = 0; j < mixs_cnt[i]; j++) {
            for (k = 0; k < pats_cnt[mixs_pats_val[i][j]]; k++) {
                if (nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][k]] > -1) {
                    //printf("try freeing music_in_ **\n");
                    free(music_in_l[i][ nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][k]]   ]);
                    free(music_in_r[i][ nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][k]]   ]);
                    // ce reboot de variable fait buguer
                    nots_cal[i][pats_nots_val[mixs_pats_val[i][j]][k]] = -1;
                }
            }
        }
    }


    //printf("music_len %d\n", music_len);

    music_len_ = music_len + 44100;
    //printf("music_len_ %d\n", music_len_);
    music_len__ = music_len_ * 2;

    //printf("music_len__ %d\n", music_len__);

    // mixage pre dithering (y en aura pas vraiment hein ...)
    // ne peut etre fait qu'a la fin des pistes car il faut connaitre la piste la plus longue pour savoir la longueur de la musique
    //printf("mixage pre dithering music_len_ %d\n", music_len_);
    music_l = (double *)malloc(sizeof(double) * music_len_);
    //PIK("music_l");
    //MIK(music_l);

    music_r = (double *)malloc(sizeof(double) * music_len_);
    //PIK("music_r");
    //MIK(music_r);

    for (i = 0; i < music_len_; i++) {
        music_l[i] = 0;
        music_r[i] = 0;
    }
    //printf("music_ pret  %d\n", i);

    for (i = 0; i < mixs_; i++) {
        for (j = 0; j < trks_len[i]; j++) {
            music_l[j] = 
            music_l[j] + music_i_l[i][j]; 
            music_r[j] = 
            music_r[j] + music_i_r[i][j]; 
        }
        free(music_in_l[i]);
        free(music_in_r[i]);
        free(music_i_l[i]);
        free(music_i_r[i]);
        free(envs_cal[i]);
        free(inss[i]);
    }
    //printf("end of i->.\nnormalisation:\n");

    // normalization
    double music_max = 0;
    double music_min = 0;
    for (i = 0; i < music_len_; i++) {
        ////printf("N scan music_ %d\n", i);
        if (music_max < music_l[i])
            music_max = music_l[i];
        if (music_max < music_r[i])
            music_max = music_r[i];
        if (music_min > music_l[i])
            music_min = music_l[i];
        if (music_min > music_r[i])
            music_min = music_r[i];
    }
        //printf("END_OF_SCAN N scan music_ %d   min:%f   max:%f\n", i, music_min, music_max);
    music_min = -music_min;
    if (music_max < music_min)
        music_max = music_min;

    //printf("music_max is %f\n", music_max);
    double normalization = 32000 / music_max;
    //printf("normalization is %f\n", normalization);


    // dithering music_ram
    int16_t *music_ram;
    music_ram = (int16_t *)malloc(sizeof(int16_t) * music_len__);
    for (i = 0; i < music_len__; i += 2) {
        music_ram[i    ] = 0;
        music_ram[i + 1] = 0;
    }
    for (i = 0; i < music_len_; i++) {
        j = i * 2;
        music_ram[j    ] = (int16_t)(music_l[i] * normalization);
        music_ram[j + 1] = (int16_t)(music_r[i] * normalization);
    }



    if (argc > 1) {

    music_len__ *= 2;
    //printf("music_len__ %d\n", music_len__);
    unsigned char data_size[4];
    data_size[0] = music_len__ >> 24;
    data_size[1] = music_len__ >> 16;
    data_size[2] = music_len__ >> 8;
    data_size[3] = music_len__ ;
    music_len__ += 36;
    unsigned char music_size[4];
    music_size[0] = music_len__ >> 24;
    music_size[1] = music_len__ >> 16;
    music_size[2] = music_len__ >> 8;
    music_size[3] = music_len__ ;

   // printf("music_size %d %d %d %d\n", music_size[0], music_size[1], music_size[2], music_size[3]);




    unsigned char music_header[44] = {
        'R', 'I', 'F', 'F', // statique
        music_size[3], music_size[2],   music_size[1],   music_size[0], // taille 32 bits du fichier (music_len_ + 36) en LE
        'W', 'A', 'V', 'E', // statique
        'f', 'm', 't', ' ', // statique
        16,   0,    0,   0, // histoire de nombre d'octets du bloc "8" ?
        1, 0, // histoire de pcm, mais je crois qu il y a jamais rien eu d autres
        2, 0, // canaux (2 car stereo)
        68, 172, 0, 0, // 44100 herz en LE
        16, 177, 2, 0, // octets a lire par secondes
        4, 0, // octets a lire par secondes
        16, 0, // bits
        'd', 'a', 't', 'a', //statique
        data_size[3], data_size[2], data_size[1], data_size[0] // taille du bloc data en LE
    };


    FILE *file = fopen(argv[1], "wb");
    if (file) {
        fwrite(music_header, 1, 44, file);
        for (i = 0; i < music_len_; i++) {
            j = i * 2;
            fwrite(&music_ram[j    ], 2, 1, file);
            fwrite(&music_ram[j + 1], 2, 1, file);
        }
        fclose(file);
    }


    }
    else {



    //printf("FIN RENDERING\n", normalization);

    int error;


    // UBUNTU

    static const pa_sample_spec ss = {
        .format = PA_SAMPLE_S16LE,
        .rate = RATE,
        .channels = 2
    };

    pa_simple *s = NULL;

        //printf("pa_simple_new.\n");
    if (!(s = pa_simple_new(NULL, argv[0], PA_STREAM_PLAYBACK, NULL, "music", &ss, NULL, NULL, &error))) {
        //printf("error: no creation of stream.\n");
        goto end;
    }
    
        //printf("pa_simple_write.\n");
    if (pa_simple_write(s, music_ram, music_len * 4, &error) < 0) {
        //printf("error: no write to stream.\n");
        goto end;
    }

        //printf("pa_simple_drain.\n");
    if (pa_simple_drain(s, &error) < 0) {
        //printf("error: no stream draining.\n");
        goto end;
    }
    //printf("pa_simple_free\n");
    pa_simple_free(s);



// DEBIAN
/*
char *dspname = "/dev/dsp";
int fd;

  if ((fd = open (dspname, O_WRONLY, 0)) == -1) {
      perror (dspname);
      //exit (-1);
  }

  int speed = RATE;
  int channels = 2;
  int bits = AFMT_S16_NE;

  if (ioctl (fd, SNDCTL_DSP_CHANNELS, &channels) == -1)
    {
      perror ("SNDCTL_DSP_CHANNELS");
      //exit (-1);
    }

  if (ioctl (fd, SNDCTL_DSP_SETFMT, &bits) == -1)
    {
      perror ("SNDCTL_DSP_SETFMT");
      //exit (-1);
    }

  if (bits != AFMT_S16_NE)
    {
      fprintf (stderr,
           "Device %s doesn't support 16 bit (native endian) format\n",
           dspname);
      //exit (-1);
    }

  if (ioctl (fd, SNDCTL_DSP_SPEED, &speed) == -1)
    {
      perror ("SNDCTL_DSP_SPEED");
      //exit (-1);
    }

    int16_t bufsize = 1024;
    int16_t buf[bufsize];
    uint32_t b = 0, y =0;
    while (1) {
    for (i = 0; i < channels; i++) {
        buf[b] = music_ram[y];
        b++;
        y++;
        if (y > music_len__) {
            //printf("fini\n");
            //exit(0);
            break;
        }

        if (b >= bufsize) {
            if (write (fd, buf, b * 2) != b * 2) {
                perror ("write");
               // exit (-1);
            }
            
            //if (delay > 0)
            //    usleep (delay * 1000);
            //    f//printf (stderr, "\r%d ", (int) (freq));
            //    fflush (stderr);
            //    p = 0;
            //}
            b = 0;
        }
    }
    }

*/





    } // fin else wav writer

    // END (CLEANING AND RETURNING)
    r = 0;
end:    

    for (i = 0; i < taps_; i++) free(taps[i]);
    for (i = 0; i < dels_; i++) free(dels[i]);


    for (i = 0; i < pats_; i++) {
        for (j = 0; j < pats_cnt[i]; j++) free(pats_nots_key[i][j]);
        free(pats_nots_val[i]);
        free(pats_nots_cnt[i]);
    }

    for (i = 0; i < mixs_; i++) {
        for (j = 0; j < mixs_cnt[i]; j++) free(mixs_pats_key[i][j]);
        free(mixs_pats_val[i]);
        free(mixs_pats_cnt[i]);
    }


        //printf("end.\n");

/*
    free(music_in_l);
    free(music_in_r);
    free(music_i_l);
    free(music_i_r);
*/
    free(music_l);
    free(music_r);
    free(music_ram);
    //free(music_data);
    return r;
}

